<?php
/**
 * Fired during plugin deactivation
 *
 * @link       http://www.webtoffee.com
 * @since      1.0.0
 *
 * @package    Wt_Smart_Coupon
 * @subpackage Wt_Smart_Coupon/includes
 */

/**
 * Fired during plugin deactivation.
 *
 * This class defines all code necessary to run during the plugin's deactivation.
 *
 * @since      1.0.0
 * @package    Wt_Smart_Coupon
 * @subpackage Wt_Smart_Coupon/includes
 * @author     Webtoffee <info@webtoffee.com>
 */
if( ! class_exists ( 'Wt_Smart_Coupon_Deactivator' ) ) {
	class Wt_Smart_Coupon_Deactivator {

		/**
		 * Short Description. (use period)
		 *
		 * Long Description.
		 *
		 * @since    1.0.0
		 */
		public static function deactivate() {
			if ( false === ( get_option( 'wt_sc_flush_rules' ) ) || 'true' === ( get_option( 'wt_sc_flush_rules' ) ) ) {
				delete_option( 'wt_sc_flush_rules' );
			}
		}

	}
}